* Even if you have push rights, do not merge your own pull requests.
* All PRs need to have an issue associated with them that they are responding to
* Your PR should fix the associated issue
* Your PR should include unit tests

Complete and delete the following checklist before issuing your pull request:

* - [ ] Limit commits to as few per pull request as sensible, so that the pull request can be focused.
* - [ ] Be intentional with PR titles
    * - [ ] Use the imperative verb in commits. Preference of "adds" over "added" or "adding."
    * - [ ] Capitalize the first word and any proper nouns.
    * - [ ] Limit to 50 characters max.
    * - [ ] Periods are not needed at the end.
        * _Bad: Button group updated_
        * _Better: Button group font updated_
        * _Best: Decreases button group's large button font weight_
* - [ ] Write a thorough description of your changes
    * - [ ] Include `fixes` with the issue number to close the issue.
    * - [ ] Explain why you wrote the code the way you wrote it, especially if you faced specific unique technical constraints/challenges.
    * - [ ] If the code change is large, give a brief outline of the changes (ie. "Adds new functionality to handle the event listening in src/listener.js").
* - [ ] Make sure the new unit tests you wrote for this PR pass.
* - [ ] Delete this checklist.
* - [ ] Issue pull request from your own fork. Remember to [sync from the upstream](https://help.github.com/articles/syncing-a-fork/).



 

